import React from 'react';
import { TimePicker } from 'antd';
const { RangePicker } = TimePicker;
import moment from 'moment';

const OnTime = (porps: any) => {
  //  disabled  是否禁止
  //  limit 默认开放时间
  //  inhibitTime  禁止选择时间
  //  onChanges  时间选择事件
  let { disabled, limit, inhibitTime, onChanges } = porps;

  // 禁止时间  数组格式
  const disabledHours = () => {
    // 禁止的小时数组
    let result = [];

    // 设施默认的开放时间
    let lim = limit ? limit.split('-') : [];
    for (var i = 0; i < 24; i++) {
      if (
        i < parseInt(moment(lim[0], 'HH:ss').format('HH')) ||
        i > parseInt(moment(lim[1], 'HH:ss').format('HH'))
      ) {
        result.push(i);
      }
    }

    // 选择日期禁止的时间
    if (inhibitTime) {
      for (let j in inhibitTime) {
        result.push(parseInt(moment(inhibitTime[j], 'HH:ss').format('HH')));
      }
    }

    // 去重排序
    return [...new Set(result)].sort((x, y) => x - y);
  };

  return (
    <>
      <RangePicker
        minuteStep={60}
        format="HH:mm"
        onChange={(time: any, timeString: any) => {
          onChanges(time, timeString);
        }}
        allowClear={false}
        disabled={disabled}
        disabledHours={disabledHours}
      />
    </>
  );
};

export default OnTime;
