import React, { useState, useEffect, useRef } from 'react';
import { Pagination } from 'antd';
import {} from '@ant-design/icons';
import ProTable from '@ant-design/pro-table';
import { RA } from '@/utils/method';
import { connect, history } from 'umi';
import moment from 'moment';

import './index.less';

const SystemFeedback = (props: any) => {
  const { dispatch, Data, loading } = props;
  const module = 'Bug';

  const [term, setTerm] = useState({ pageNum: 1 } as any); //页码

  useEffect(() => {
    if (!Data) {
      Refresh();
    }
  }, [Data]);

  const columns = [
    { title: 'Brand', dataIndex: 'phoneBrand' },
    { title: 'Phone model', dataIndex: 'deviceModel' },
    { title: 'System version', dataIndex: 'osVersion' },
    { title: 'Software version', dataIndex: 'appVersion' },
    { title: 'Problem Description', dataIndex: 'description', ellipsis: true },
    {
      title: 'Submission time',
      dataIndex: 'createTime',
      render: (text: any) => {
        let data =
          moment(text.time).format('YYYY-MM-DD hh:mm') +
          // ':00' +
          (parseInt(moment(text.time).format('HH')) > 11 ? ' PM' : ' AM');

        // let data = moment(text.time).calendar();
        return data;
      },
    },
    {
      title: 'Actions',
      valueType: 'option',
      render: (text: any) => {
        return (
          <a
            key="link"
            onClick={() => {
              Details(text);
            }}
          >
            Details
          </a>
        );
      },
    },
  ];

  // 跳到内页
  const Details = (item: any) => {
    let DataSave = item;
    dispatch({ type: 'Bug/SA', DataSave });
    history.push('/AccountManagement/SystemFeedback/BugDetail');
  };

  // 页码切换
  const sopens = (page: any) => {
    let p = {
      pageNum: page,
    };
    setTerm({ ...p });
    RA(59, p, module, dispatch);
  };

  // 刷新
  const Refresh = () => {
    RA(59, term, module, dispatch);
  };

  return (
    <>
      <ProTable
        dataSource={Data ? Data.list : null}
        rowKey={'id'}
        columns={columns as any}
        pagination={false}
        options={{
          density: false,
          fullScreen: false,
          reload: () => {
            Refresh();
          },
          setting: false,
        }}
        loading={loading}
        search={false}
        headerTitle="System Feedback"
      />
      <div className="pages">
        <Pagination
          // onShowSizeChange={pageSizeHandler}
          current={Data ? Data.page.currentPage : 0}
          onChange={sopens}
          total={Data ? Data.page.totalRow : 0}
          pageSize={Data ? Data.page.curPageSize : 0}
          showSizeChanger={false}
        />
      </div>
    </>
  );
};

function mapStateToProps(state: any) {
  const { Data } = state.Bug;
  const loading = state.loading.models.Bug || false;
  return {
    Data,
    loading,
  };
}

export default connect(mapStateToProps)(SystemFeedback);
