import React, { useState, useEffect, useRef } from 'react';
import './css/index.less';
import { Input, InputNumber, Button, Form, Select, message, Spin, TimePicker } from 'antd';
const { Option } = Select;
const { RangePicker } = TimePicker;

import { connect, history } from 'umi';
import PictureOptionsRow from '@/components/PictureOptions/PictureOptionsRow';
import TitleBack from '@/components/TitleBack/TitleBack';
import { getNumber } from '@/utils/string';

import SearchOptionsCommnity from '@/components/SearchOptions/SearchOptionsCommnity';

import { NewFaci } from '@/utils/tip';

import Facilitys from '@/components/Facilitys/Facilitys';

import { getUrlLast } from '@/utils/string';
import { validateMessages } from '@/utils/params';

const module = 'FacilityBookings';
import moment from 'moment';

const Facility = (props: any) => {
  const { dispatch, location, token, sourceData, DataSave, Result, load, FacilitysList } = props;

  const RA = (index: any, values: any) => {
    dispatch({ type: 'FacilityBookings/RA', playload: { index: index, body: values } });
  };
  const ResultClear = () => {
    dispatch({ type: 'FacilityBookings/ResultClear' });
  };

  const [pictrueExtend, setPictrueExtend] = useState({ pic: null, pics: null, tab: 3 });
  const [facilityDetail, setFacilityDetail] = useState(false); // 全部禁止
  const [Community, setCommunity] = useState(false); // 小区全部禁止
  const [PATHNAME, setPATHNAME] = useState('');

  const formRef = useRef(null as any);

  const [fileList, setFileList] = useState([] as any); // 图片列表组

  // 监听是否选择了小区
  const [imgOpen, setImgOpen] = useState(true);
  const [ctyName, setCtyName] = useState(null);

  const [Cycle, setCycle] = useState(null as any); // Appointment Cycle下拉

  // 表单标识
  const [form] = Form.useForm();

  useEffect(() => {
    if (Result != null) {
      ResultClear();
      history.push('/CommunityManagement/FacilityBookings');
    }
  }, [Result]);

  const RA_S = () => {
    if (DataSave != null) {
      RA(7, {
        userToken: token,
        facilitieId: DataSave.id,
      });
    } else {
      history.go(-1);
    }
  };
  useEffect(() => {
    if (sourceData != null) {
      setCommunity(true);
      setCtyName(DataSave.communityName);

      // 中断
      // setPictrueExtend({tab:null,pic:null,pics:null})
      // 设施图片默认值
      let list: any = sourceData.categoriesName.map((item: any, index: any) => {
        let sam = {
          id: index,
          name: item.name,
          fileList: [
            {
              uid: item.id,
              name: item.imgName,
              status: 'done',
              url: item.url,
            },
          ],
        };
        // 设施图片列表默认值
        form.setFieldsValue({
          ['shebei_' + index]: item.name,
        });
        return sam;
      });

      dispatch({ type: module + '/genxin', list });

      // 当是查看的时候禁止点击
      location.pathname.indexOf('FacilityDetail') > -1 ? setImgOpen(true) : setImgOpen(false);

      setFileList(sourceData.categoriesDetailsImageName); //设置图片组名称
      // delete sourceData.categoriesDetailsImageName;
      setCycle(sourceData.periodType + '');

      // delete sourceData.periodType;

      // 设置表单默认值
      formRef.current.setFieldsValue(sourceData);
    } else {
      // 新增页面进来 先清一遍 图片列表
      let list: any = [];
      dispatch({ type: module + '/genxin', list });
    }
  }, [sourceData]);

  useEffect(() => {
    var tmp = pictrueExtend;
    if (location.pathname.indexOf('FacilityEdit') > -1) {
      setPATHNAME('Edit Facility');
      tmp.tab = 1;
      setPictrueExtend(tmp);
      RA_S();
    } else if (location.pathname.indexOf('FacilityDetail') > -1) {
      setFacilityDetail(true); // 设置禁止

      tmp.tab = 2;
      setPictrueExtend(tmp);
      setPATHNAME('Facility Detail');
      RA_S();
    } else {
      tmp.tab = 3;
      setPictrueExtend(tmp);
      setPATHNAME('Add Facility');
    }
  }, []);

  // const TimeSelectRef = (values:any) => {
  //   setRef3(values)
  // }

  // 判断数组是否有重复项
  function isRepeat(arr: any) {
    let hash = {};
    for (let i in arr) {
      if (hash[arr[i]]) {
        return true;
      }
      hash[arr[i]] = true;
    }
    return false;
  }
  // 提交
  const onFinish = (values: any) => {
    // 先判断是否填写完整
    for (let j in FacilitysList) {
      if (FacilitysList[j].fileList.length == 0) {
        message.error('Please upload classified pictures of facilities!');
        return false;
      }
    }

    // 过滤表单;
    let imgs: any = []; // 小设施图片  -- 用作提交
    let name = []; // 小设施名称  -- 用作判断重名
    for (let i in FacilitysList) {
      // 设施名称不能为空
      if (FacilitysList[i].name == '') {
        message.error('Facility name cannot be empty!');
        return false;
      }
      name.push(FacilitysList[i].name);
      imgs[
        i
      ] = `${FacilitysList[i].name}&${FacilitysList[i].fileList[0].name}&${FacilitysList[i].fileList[0].uid}`;
    }

    // 如果小设施有重名
    if (isRepeat(name)) {
      message.error('Facility name cannot be repeated!');
    } else if (imgs.length == 0) {
      // 图片设施判断
      message.error('Please Upload At Least One Facility!');
    } else if (!values.Time) {
      // 判断时间选择
      message.error('Please Fill In The Appointment Period!');
    } else if (
      // 提前预订时间大于 取消时间
      values.canReservationDay < values.cancelReservationDay ||
      values.canReservationDay < values.nomarginCancelReservationDay
    ) {
      message.error('Reservation should be greater than cancellation time!');
    } else {
      let categoriesName: any = imgs; // 设施图片
      values.categoriesName = categoriesName; // 设施内容
      values.reservationQuantumTime = [
        moment(values.Time[0]).format('HH:mm'),
        moment(values.Time[1]).format('HH:mm'),
      ]; // 开放时间段
      values.categoriesOpenTime = `${moment(values.Time[0]).format('HH:mm')}-${moment(
        values.Time[1],
      ).format('HH:mm')}`; // 预约时间段  二开需要
      values.communityManagerFee = values.communityManagerFee ? values.communityManagerFee : '0.00'; // 价格押金没有为0
      values.communityMargin = values.communityMargin ? values.communityMargin : '0.00'; // 价格押金没有为0

      values.periodType = Cycle;
      delete values.picList;
      delete values.Time;

      RA(6, values);
    }
    return false;
  };

  const Subscribe = () => {
    history.push(getUrlLast(location.pathname) + '/FacilityApply');
  };
  const keyup_tool = (value: any) => {
    return getNumber(value.replace(/[^\d^\.]+/g, ''));
  };
  const keyup_communityManagerFee = (e: any) => {
    e.target.value = keyup_tool(e.target.value);
    formRef.current.setFieldsValue({ communityManagerFee: e.target.value });
  };
  const keyup_communityMargin = (e: any) => {
    e.target.value = keyup_tool(e.target.value);
    formRef.current.setFieldsValue({ communityMargin: e.target.value });
  };

  const keyup = (keyname: any, e: any) => {
    e.target.value = e.target.value.replace(/[^\d^\.]+/g, '');
    var tmp = {};
    tmp[keyname] = e.target.value;
    formRef.current.setFieldsValue(tmp);
  };

  //选择周期
  function handleChange(value: any) {
    setCycle(value);
  }

  // 选择小区名字并赋值
  const opname = (value: any) => {
    if (value == '') {
      eliminate();
    } else {
      if (ctyName == null) {
        setImgOpen(false); // 允许图片上传
        setCtyName(value); // 给小区赋值
        form.setFieldsValue({
          communityName: value, // 给表单赋值
        });
      } else if (value != ctyName) {
        // eliminate();
        // 清空设施列表图
        // console.log('不等于');
        setCtyName(value); // 给小区赋值
        let list: any = [];
        dispatch({ type: module + '/genxin', list });
        setFileList(null);
        //去掉图片组
        form.setFieldsValue({
          categoriesDetailsImageName: [],
          communityName: value, // 给表单赋值
        });
      }
    }
  };

  // 切换小区清除小区附件列表
  const eliminate = () => {
    setCtyName(null);
    // 设置是否能点击上传
    setImgOpen(true);
    // 清空设施列表图
    let list: any = [];
    dispatch({ type: module + '/genxin', list });

    setFileList(null);
    //去掉图片组
    form.setFieldsValue({
      categoriesDetailsImageName: [],
    });
  };

  // 子组件清除表单的 输入框值
  // const dumps = (key: any) => {
  //   form.setFieldsValue({
  //     ['shebei_' + key]: '',
  //   });
  // };

  //时间
  const onChanges = (value: any, b: any) => {
    // console.log(value);
    // console.log(b);
    // 修改后的时间
    formRef.current.setFieldsValue({
      Time: [moment(b[0], 'HH:mm'), moment(b[1], 'HH:mm')],
    });
  };

  return (
    <>
      <Spin spinning={load}>
        <div className={'base basediy'}>
          {/* 头部组件v1.2 */}
          <TitleBack title={PATHNAME} url={getUrlLast(location.pathname) + '?Facility=true'} />
          <Form
            ref={formRef}
            form={form}
            name="basic"
            onFinish={onFinish}
            validateMessages={validateMessages}
          >
            {/* 选择小区 */}
            <Form.Item label="Community" name="communityName" rules={NewFaci[0]}>
              <SearchOptionsCommnity
                // ubmit={extendName}
                defaultName={DataSave != null ? DataSave.communityName : null}
                opname={opname}
                disabled={facilityDetail || Community}
              />
            </Form.Item>

            {/* 设施名称 以及费用 */}
            <Input.Group>
              <Form.Item label="Facility Classification" name="facilityName" rules={NewFaci[1]}>
                <Input
                  placeholder="Facility Classification"
                  disabled={facilityDetail}
                  maxLength={30}
                />
              </Form.Item>
              <span className="divIconMoney">Fee($):</span>
              <Form.Item label="" name="communityManagerFee">
                <InputNumber
                  onKeyUp={keyup_communityManagerFee}
                  prefix="$"
                  placeholder="00.00"
                  disabled={facilityDetail}
                  min={0}
                  max={999}
                  step={0.01}
                  style={{ width: '120px' }}
                />
              </Form.Item>
              <span className="divIconMoney">Deposit:</span>
              <Form.Item label="" name="communityMargin">
                <InputNumber
                  onKeyUp={keyup_communityMargin}
                  prefix="$"
                  placeholder="00.00"
                  disabled={facilityDetail}
                  min={0}
                  max={999}
                  step={0.01}
                  style={{ width: '120px' }}
                />
              </Form.Item>
            </Input.Group>

            <hr></hr>

            {/* 设施品类上传 */}
            <Form.Item label="Facilities" className="flex required" style={{ marginBottom: 0 }}>
              <Facilitys
                disabled={imgOpen}
                updata={{
                  // userToken: token,
                  imageType: 'categoriesImageName',
                  extends: ctyName,
                }}
              ></Facilitys>
            </Form.Item>

            {/* 设施详情上传 */}
            <Form.Item
              name="categoriesDetailsImageName"
              label="Facility Pictures"
              rules={NewFaci[4]}
            >
              <PictureOptionsRow
                over={imgOpen}
                data={{
                  // userToken: token,
                  imageType: 'categoriesDetailsImageName',
                  extends: ctyName,
                }}
                limitNums={99}
                value={fileList}
              />
            </Form.Item>

            {/* 时间 */}
            <Form.Item label="Opening Hours" className="required">
              <Form.Item name="Time" noStyle>
                <RangePicker
                  disabled={imgOpen}
                  minuteStep={60}
                  format="HH:mm"
                  onChange={(time: any, timeString: any) => {
                    onChanges(time, timeString);
                  }}
                  allowClear={false}
                />
              </Form.Item>
            </Form.Item>

            <hr></hr>

            {/* ------------- */}
            <p className="diyp">Booking Rules : </p>

            {/* 预约设置 */}
            <Input.Group>
              <Form.Item name="cancelReservationDay" label="Early Cancellation" rules={NewFaci[5]}>
                <Input
                  onKeyUp={keyup.bind(this, 'cancelReservationDay')}
                  disabled={facilityDetail}
                  // prefix="Advance"
                  suffix="Day(s) In Advance"
                  style={{ width: 160, textAlign: 'center' }}
                  placeholder="0"
                  maxLength={2}
                />
              </Form.Item>
              <Form.Item
                label="No Deposit To Cancel Reservation"
                name="nomarginCancelReservationDay"
                rules={NewFaci[6]}
              >
                <Input
                  onKeyUp={keyup.bind(this, 'nomarginCancelReservationDay')}
                  disabled={facilityDetail}
                  // prefix="Advance"
                  suffix="Day(s) In Advance"
                  style={{ width: 160, textAlign: 'center' }}
                  placeholder="0"
                  maxLength={2}
                />
              </Form.Item>
              <Form.Item label="Booking" name="canReservationDay" rules={NewFaci[7]}>
                <Input
                  onKeyUp={keyup.bind(this, 'canReservationDay')}
                  placeholder="0"
                  style={{ width: 160, textAlign: 'center' }}
                  disabled={facilityDetail}
                  // prefix="Advance"
                  suffix="Day(s) In Advance"
                  maxLength={2}
                />
              </Form.Item>
            </Input.Group>

            {/* 设置次数 */}
            <Input.Group>
              <Form.Item label="Booking Quotas" rules={NewFaci[8]}>
                <Select
                  placeholder="Cycle"
                  allowClear
                  style={{ width: 120 }}
                  disabled={facilityDetail}
                  value={Cycle}
                  onChange={handleChange}
                >
                  <Option value="1">Week</Option>
                  <Option value="2">Month</Option>
                  <Option value="3">Year</Option>
                </Select>
              </Form.Item>
              <Form.Item name="canReservationNum" rules={NewFaci[9]}>
                <Input
                  onKeyUp={keyup.bind(this, 'canReservationNum')}
                  placeholder="Second"
                  style={{ width: 120 }}
                  disabled={facilityDetail}
                  defaultValue={0}
                  suffix="Time(s)"
                />
              </Form.Item>
            </Input.Group>

            <hr></hr>

            {facilityDetail ? (
              <>
                {imgOpen ? (
                  <Button type="primary" onClick={Subscribe} loading={load} disabled={imgOpen}>
                    Subscribe
                  </Button>
                ) : (
                  ''
                )}
              </>
            ) : (
              <>
                <Button type="primary" htmlType="submit" loading={load}>
                  Submit
                </Button>
              </>
            )}
          </Form>
        </div>
      </Spin>
    </>
  );
};

function mapStateToProps(state: any) {
  const { sourceData, DataSave, Result, FacilitysList } = state.FacilityBookings;
  const { token } = state.login;
  const load =
    typeof state.loading.models.FacilityBookings == 'undefined'
      ? false
      : state.loading.models.FacilityBookings;
  return {
    DataSave,
    sourceData,
    token,
    Result,
    load,
    FacilitysList,
  };
}
export default connect(mapStateToProps)(Facility);
